#include <stdio.h>
#include <Winsock2.h>
#include <Ws2tcpip.h>
#include <thread>
#include <chrono>
#include <vector>
#include <iostream>
#include <sstream>
#include<map>
#include<queue>
#include <mutex>
#pragma comment(lib, "ws2_32")
std::queue<char*> data;
std::map<SOCKET, std::thread::id> socket_thread_id;//洢SOCKET sockConnԼӦthread_id
std::mutex dataMutex;// ȫַΧ廥
std::mutex sendMutex;
static auto printThreadId() {
    std::thread::id this_id = std::this_thread::get_id();
    std::stringstream ss;
    ss << this_id;
    return ss.str();
}
static void get_socket_thread_id(SOCKET sockConn, std::map<SOCKET, std::thread::id>& socket_thread_id) {
    std::thread::id this_id = std::this_thread::get_id();
    if (socket_thread_id.find(sockConn) == socket_thread_id.end()) {
        socket_thread_id[sockConn] = this_id;
    }
}

void HandleClient(SOCKET sockConn, const SOCKADDR_IN& addrClient, std::map<SOCKET, std::thread::id>& socket_thread_id) {
    char sendBuf[50];
    if (inet_ntop(AF_INET, &(addrClient.sin_addr), sendBuf, sizeof(sendBuf) / sizeof(sendBuf[0])) == NULL) {
        fprintf(stderr, "inet_ntop failed with error: %d\n", WSAGetLastError());
        closesocket(sockConn);
        return;
    }

    int flag = true;
    while (1) {
        if (flag) {
            std::cout << "ԣ" << sockConn << "   Welcome " << sendBuf << " to here!\n";
            flag = false;
            get_socket_thread_id(sockConn, socket_thread_id);
            // ȡ˳dataMutex -> sendMutex
            dataMutex.lock();
            sendMutex.lock();
            send(sockConn, sendBuf, strlen(sendBuf) + 1, 0);
            sendMutex.unlock();
            dataMutex.unlock();
        }

        char recvBuf[1025];
        int bytesReceived = recv(sockConn, recvBuf, sizeof(recvBuf), 0);//Ϣ

        if (bytesReceived <= 0) {
            int error = WSAGetLastError();
            printf("Connection from %s closed or error occurred. Error code: %d\n", sendBuf, error);

            if (error == 10054) {
                printf("Client closed the connection.\n");
            }

            break;
        }
        recvBuf[bytesReceived] = '\0';  // ַ
        std::cout << "ܵϢ" << recvBuf << std::endl;


        for (auto& it : socket_thread_id) {  //Ϣ͸ÿһͻ
            
            if (it.second != std::this_thread::get_id())//Ŀͻ
            {
                int bytesSent = send(it.first, recvBuf, std::strlen(recvBuf) + 1, 0);
                if (bytesSent == SOCKET_ERROR) {
                    int error = WSAGetLastError();
                    std::cerr << "send failed with error: " << error << std::endl;
                }
                else
                {
                    std::cout << "͸" << it.first << std::endl;
                }
            }
            
        }
        

        dataMutex.lock();
        data.push(recvBuf);
        dataMutex.unlock();
    }

    socket_thread_id.erase(sockConn);
    closesocket(sockConn);
}

//void send_data(SOCKET sockConn, std::map<SOCKET, std::thread::id>& socket_thread_id) {
//    while (true) {
//        while (socket_thread_id.size()) {
//            while (!data.empty()) {
//                // ȡ˳dataMutex -> sendMutex
//                dataMutex.lock();
//                char* chat_data_iterator = data.front(); data.pop();
//                std::string chat_data(chat_data_iterator);
//
//                for (auto& it : socket_thread_id) {
//                    std::stringstream ss;
//                    ss << socket_thread_id[sockConn];
//                    chat_data += " from " + ss.str();
//
//                    sendMutex.lock();
//                    int bytesSent = send(it.first, chat_data.c_str(), strlen(chat_data.c_str()) + 1, 0);
//                    if (bytesSent == SOCKET_ERROR) {
//                        int error = WSAGetLastError();
//                        std::cerr << "send failed with error: " << error << std::endl;
//                    }
//                    std::cout << printThreadId();
//                    sendMutex.unlock();
//
//                    std::cout << "͵" << it.first << "Ϣ" << chat_data << std::endl;
//                }
//                dataMutex.unlock();
//                delete chat_data_iterator;
//            }
//            break;
//        }
//    }
//}

 

int main() {
    WORD wVersionRequested;
    WSADATA wsaData;
    int err;
    


    wVersionRequested = MAKEWORD(2, 2); // ʹýϸ߰汾 Winsock

    err = WSAStartup(wVersionRequested, &wsaData);
    if (err != 0) {
        fprintf(stderr, "WSAStartup failed with error: %d\n", err);
        return 1; // ش
    }

    if (LOBYTE(wsaData.wVersion) != 2 || HIBYTE(wsaData.wVersion) != 2) {
        fprintf(stderr, "Could not find a usable version of Winsock.dll\n");
        WSACleanup();
        return 1; // ش
    }

    SOCKET sockSrv = socket(AF_INET, SOCK_STREAM, 0);
    if (sockSrv == INVALID_SOCKET) {
        fprintf(stderr, "socket creation failed with error: %ld\n", WSAGetLastError());
        WSACleanup();
        return 1; // ش
    }

    // õַѡ
    int opt = 1;
    if (setsockopt(sockSrv, SOL_SOCKET, SO_REUSEADDR, (const char*)&opt, sizeof(opt)) == SOCKET_ERROR) {
        fprintf(stderr, "setsockopt failed with error: %d\n", WSAGetLastError());
        closesocket(sockSrv);
        WSACleanup();
        return 1; // ش
    }

    SOCKADDR_IN addrSrv;
    addrSrv.sin_addr.S_un.S_addr = htonl(INADDR_ANY);
    addrSrv.sin_family = AF_INET;
    addrSrv.sin_port = htons(6000);

    if (bind(sockSrv, (SOCKADDR*)&addrSrv, sizeof(SOCKADDR)) == SOCKET_ERROR) {
        fprintf(stderr, "bind failed with error: %d\n", WSAGetLastError());
        closesocket(sockSrv);
        WSACleanup();
        return 1; // ش
    }

    if (listen(sockSrv, 5) == SOCKET_ERROR) {
        fprintf(stderr, "listen failed with error: %d\n", WSAGetLastError());
        closesocket(sockSrv);
        WSACleanup();
        return 1; // ش
    }

    std::vector<std::thread> threads;

    while (true) {
        SOCKET sockConn = accept(sockSrv, NULL, NULL);
        if (sockConn == INVALID_SOCKET) {
            std::cerr << "accept failed with error: " << WSAGetLastError() << std::endl;
            continue;
        }

        // һ߳ͻ
        threads.emplace_back(HandleClient, sockConn, addrSrv, std::ref(socket_thread_id));
        //sockConnͿʵֶͻ
    }

    // رշ׽ֺ Winsock 
    closesocket(sockSrv);
    WSACleanup();

    return 0;
}
